<template>
  <div id='tasks_content'>
    <router-link id='new_task_link' to="/tasks/new">Create new task</router-link>
    <h1>Tasks:</h1>
    <table class="table">
      <tr>
        <th> Task name </th>
        <th> </th>
      <tr>
      <tr v-for='task in tasks' :id='"task_"+task.id'>
        <td>
          <router-link  class='task_link' :to='"/tasks/"+task.id'> {{ task.title }} </router-link>
        </td>
        <td>
          <task-action-btn :task='task'></task-action-btn>
        </td>
      </tr>
    </table>
  </div>
</template>


<script>
  export default {
    data () {
      return {
        email: '',
        logged: this.$store.state.logged,
        tasks: []
      }
    },
    mounted() {
      if(!this.$store.state.logged) {
        this.$root.$emit('setFlashMsg', { message: 'You must be logged to visit this page', type: 'error' })
        this.$router.push('/sign_in')
      }
      this.loadTasks()
    },
    methods: {
      loadTasks() {
        const url = '/api/v1/tasks'
        this.$http.get(url, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.tasks = response.body.tasks
        })
      },
      deleteTask(task) {
        let taskIndex = this.tasks.indexOf(task)
        this.tasks.splice(taskIndex, 1)
      }
    }
  }
</script>
